%Ejemplo de simulacin  para el clculo del error cuadrtico medio
%cometido en la estimacin del parmetro theta mediante fi estimadores.
n=input('introduzca el tamao del cluster');
N=input('introduzca el nmero de poblaciones');
% el coeficiente de dependencia 0<c<1 cuanto mas prximo est a 1 mayor
% dependencia
a=input('introduzca el coeficiente de dependencia');
K=input('introduzca el nmero de muestras a generar');
% verdadero valor del parmetro 
th=[0.0209;-0.2385; 0.0754; -0.1445; 0.1261;-0.3941];
% Matriz del modelo loglineal sin interacin (no saturado)
 W=[ 1	1	1	1	1	1;
1	1	1	-1	-1	-1;
1	-1	-1	1	1	-1;
1	-1	-1	-1	-1	1;
-1	1	-1	1	-1	1;
-1	1	-1	-1	1	-1;
-1	-1	1	1	-1	-1;
-1	-1	1	-1	1	1 ]; 
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
den=sum(exp(W*th));
vp=(exp(W*th))/den;
%Inicializamos la matrices que van a contener las muestras  multinomiales y las probabilidades estimadas
A=zeros(N,n);
M=length(vp);
M0=length(th);
Pest=zeros(M,K);
%generamos K muestras formadas N observaciones de cluster de tamao n a partir de las cuales estimamos las probabilidades
for h=1:K 
for j=1:N
    A(j,:) =RNDistCohen(vp,n,a);
 end;
 AT=A(:);
T=tabulate(A(:));
nT=size(T);
  for i=1:nT(1,1)
     Pest(T(i,1),h)=T(i,3)/100;
   end;
  for i=1:M
    if Pest(i,h)==0;
        Pest(i,h)=0.000001;
    end;
  end;
end;
mse=zeros(K,5);
mset=zeros(1,5);
msem=zeros(1,5);
TH=zeros(M0,K);
PTH=zeros(M,K);
 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = th;
X0(1) = th(1)+0.5;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
  for j=1:K
  fidiv=@(x)(sum((Pest(:,j).^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
fidiv0=@(x)(Pest(:,j))'*log(Pest(:,j)./((exp(W*x))/sum(exp(W*x))));
fidiv1=@(x)((exp(W*x))/sum(exp(W*x)))'*log((exp(W*x))/sum(exp(W*x))./(Pest(:,j)));

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,j)= fmincon(fidiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,j)= fmincon(fidiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,j)= fmincon(fidiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,j)= (exp(W*TH(:,j)))/sum(exp(W*TH(:,j)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(j,i)=(TH(:,j)-th)'*(TH(:,j)-th)/M0;
   mset(1,i)=mse(j,i)+mset(1,i);
   msem(1,i)=mset(1,i)/N;
  end;
 end;

