function x = discreternd(p, n)
% genera nmeros aleatorios de una distribucin Multinomial
% de parmetros p.  sum(p)~=1 y n
if nargin == 1
    n = 1;
end
r = rand(1,n);   % n valores aleatorios de la uniforme en (0,1)
p = cumsum(p(:)); % Crea un vector con las probabilidades acumuladas de p
x = sum(repmat(r,length(p),1) > repmat(p/p(end),1,n),1)+1;
[~,x] = histc(r,[0;p/p(end)]);