%Datos de von Eye (pag 46) donde un grupo de 182 individuos, 133 mujeres y 49
%hombres, evaluaron un 2 proverbios segn su concretitud y significado

%Clculo del estimador deL MODELO LOGLINEAL PARA MEDIR EL GRADO DE ACUERDO 
Y=[20; 23; 8; 82; 12; 6; 6; 25];

N = size(Y,1);
ntot=sum(sum(Y));

  %Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global  W TH0 M M0 Pest;
  clear W TH0 M M0  Pest;
  
% verdadero valor del parmetro utilizado como valor inicial
TH0=[0.1;0.1;-0.1 ;-0.40];
% Matriz del modelo loglineal(1)sin interacin 
W=[1  1  1  1 ; 
   1  1  1 -1 ; 
   1  1 -1  1 ; 
   1  1 -1 -1 ;
   1 -1  1  1 ;
   1 -1  1 -1 ; 
   1 -1 -1  1 ;
   1 -1 -1 -1] ;
    
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
den=sum(exp(W*TH0));
vp=(exp(W*TH0))/den;
M=length(vp);
M0=length(TH0);
%valores de las frecuencias para cada una de las posibles respuestas
Pest=Y./ntot;
 mse=zeros(1,5);
TH=zeros(M0,5);
PTH=zeros(M,5);
T1=zeros(5,1);
T1B=zeros(5,1);
 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end
   fidiv=@(x)(sum((Pest.^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
fidiv0=@(x)(Pest)'*log(Pest./((exp(W*x))/sum(exp(W*x))));
fidiv1=@(x)((exp(W*x))/sum(exp(W*x)))'*log((exp(W*x))/sum(exp(W*x))./(Pest));

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i)= fmincon(fidiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,i)= fmincon(fidiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,i)= fmincon(fidiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,i)= (exp(W*TH(:,i)))/sum(exp(W*TH(:,i)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(1,i)=(TH(:,i)-TH0)'*(TH(:,i)-TH0)/M0;
    if land==0 
     for m=1:M
       if Pest(m)==0
          Div(m)=0;
         else
        Div(m)=Pest(m)*log(Pest(m)/PTH(m,i));
       end;
     end;
      T1(i)=2*ntot*sum(Div);
      T1B(i)=2*ntot*sum(Div);
     
  else
   T1(i)=2*ntot*(sum((Pest.^(land+1))./PTH(:,i).^land)-1)/(land*(land+1)); 
     T1B(i)=2*ntot*(sum((Pest.^(land+1))./PTH(:,i).^land)-1)/(land*(land+1));
  end;
end;

 %Pasamos a estimar el siguiente modelo caso (2)caso de pesos iguales en
 %los acuerdos pero sin la triple interacin
 
  clear W TH0 M M0  Pest;
  
% verdadero valor del parmetro utilizado como valor inicial
TH0=[0.1;0.1;-0.1 ;-0.40;0.04;-0.21; 0.4; ];
% Matriz del modelo loglineal QUE INCLUYE LA TRIPLE  interacin 
W=[1  1  1  1  1  1 1 ; 
   1  1  1 -1  1 -1 0; 
   1  1 -1  1 -1  1 0; 
   1  1 -1 -1 -1 -1 1;
   1 -1  1  1 -1 -1 1;
   1 -1  1 -1 -1  1 0; 
   1 -1 -1  1  1 -1 0;
   1 -1 -1 -1  1  1 1] ;
    
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
den=sum(exp(W*TH0));
vp=(exp(W*TH0))/den;
M=length(vp);
M0=length(TH0);
%valores de las frecuencias para cada una de las posibles respuestas
Pest=Y./ntot;
 mse=zeros(1,5);
TH=zeros(M0,5);
PTH=zeros(M,5);
T2=zeros(5,1);
T2B=zeros(5,1);
 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end
   fidiv=@(x)(sum((Pest.^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
fidiv0=@(x)(Pest)'*log(Pest./((exp(W*x))/sum(exp(W*x))));
fidiv1=@(x)((exp(W*x))/sum(exp(W*x)))'*log((exp(W*x))/sum(exp(W*x))./(Pest));

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i)= fmincon(fidiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,i)= fmincon(fidiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,i)= fmincon(fidiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,i)= (exp(W*TH(:,i)))/sum(exp(W*TH(:,i)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(1,i)=(TH(:,i)-TH0)'*(TH(:,i)-TH0)/M0;
   %Elestadstico de bondad de ajuste 
   if land==0 
     for m=1:M
       if Pest(m)==0
          Div(m)=0;
         else
        Div(m)=Pest(m)*log(Pest(m)/PTH(m,i));
       end;
     end;
      T2(i)=2*ntot*sum(Div);
      T2B(i)=2*ntot*sum(Div);
    else
   T2(i)=2*ntot*(sum((Pest.^(land+1))./PTH(:,i).^land)-1)/(land*(land+1)); 
     T2B(i)=2*ntot*(sum((Pest.^(land+1))./PTH(:,i).^land)-1)/(land*(land+1)); 
   end;
end;


 %Pasamos a estimar el siguiente modelo caso (3)caso de pesos iguales en
 %los acuerdos pero sin la triple interacin
 
  clear W TH0 M M0  Pest;
  
% verdadero valor del parmetro utilizado como valor inicial
TH0=[0.1;0.1;-0.1 ;-0.40;0.04;-0.21; 0.4;0.3 ];
% Matriz del modelo loglineal QUE INCLUYE LA TRIPLE  interacin 
W=[1  1  1  1  1  1 1  1; 
   1  1  1 -1  1 -1 0  0; 
   1  1 -1  1 -1  1 0  0; 
   1  1 -1 -1 -1 -1 1  1;
   1 -1  1  1 -1 -1 1  0;
   1 -1  1 -1 -1  1 0  0; 
   1 -1 -1  1  1 -1 0  0;
   1 -1 -1 -1  1  1 1  0] ;
    
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
den=sum(exp(W*TH0));
vp=(exp(W*TH0))/den;
M=length(vp);
M0=length(TH0);
%valores de las frecuencias para cada una de las posibles respuestas
Pest=Y./ntot;
 mse=zeros(1,5);
TH=zeros(M0,5);
PTH=zeros(M,5);
T=zeros(5,1);
TB=zeros(5,1);
 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end
   fidiv=@(x)(sum((Pest.^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
fidiv0=@(x)(Pest)'*log(Pest./((exp(W*x))/sum(exp(W*x))));
fidiv1=@(x)((exp(W*x))/sum(exp(W*x)))'*log((exp(W*x))/sum(exp(W*x))./(Pest));

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i)= fmincon(fidiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,i)= fmincon(fidiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,i)= fmincon(fidiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,i)= (exp(W*TH(:,i)))/sum(exp(W*TH(:,i)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(1,i)=(TH(:,i)-TH0)'*(TH(:,i)-TH0)/M0;
    if land==0 
     for m=1:M
       if Pest(m)==0
          Div(m)=0;
         else
        Div(m)=Pest(m)*log(Pest(m)/PTH(m,i));
       end;
     end;
      T(i)=2*ntot*sum(Div);
      TB(i)=2*ntot*sum(Div);
     
  else
   T(i)=2*ntot*(sum((Pest.^(land+1))./PTH(:,i).^land)-1)/(land*(land+1)); 
     TB(i)=2*ntot*(sum((Pest.^(land+1))./PTH(:,i).^land)-1)/(land*(land+1)); 
  end;
end;

    %Pasamos a estimar el siguiente modelo caso (4)caso solo usa la triple
    %interacin con delta
 
  clear W TH0 M M0  Pest;
  
% verdadero valor del parmetro utilizado como valor inicial
TH0=[0.1;0.1;-0.1 ;-0.40;0.04;-0.21; 0.3 ];
% Matriz del modelo loglineal QUE INCLUYE LA TRIPLE  interacin 
W=[1  1  1  1  1  1  1; 
   1  1  1 -1  1 -1   0; 
   1  1 -1  1 -1  1   0; 
   1  1 -1 -1 -1 -1   1;
   1 -1  1  1 -1 -1  0;
   1 -1  1 -1 -1  1  0; 
   1 -1 -1  1  1 -1  0;
   1 -1 -1 -1  1  1  0] ;
    
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
den=sum(exp(W*TH0));
vp=(exp(W*TH0))/den;
M=length(vp);
M0=length(TH0);
%valores de las frecuencias para cada una de las posibles respuestas
Pest=Y./ntot;
 mse=zeros(1,5);
TH=zeros(M0,5);
PTH=zeros(M,5);
T4=zeros(5,1);
T4B=zeros(5,1);
 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end
   fidiv=@(x)(sum((Pest.^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
fidiv0=@(x)(Pest)'*log(Pest./((exp(W*x))/sum(exp(W*x))));
fidiv1=@(x)((exp(W*x))/sum(exp(W*x)))'*log((exp(W*x))/sum(exp(W*x))./(Pest));

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i)= fmincon(fidiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,i)= fmincon(fidiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,i)= fmincon(fidiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,i)= (exp(W*TH(:,i)))/sum(exp(W*TH(:,i)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(1,i)=(TH(:,i)-TH0)'*(TH(:,i)-TH0)/M0;
   if land==0 
     for m=1:M
       if Pest(m)==0
          Div(m)=0;
         else
        Div(m)=Pest(m)*log(Pest(m)/PTH(m,i));
       end;
     end;
      T4(i)=2*ntot*sum(Div);
      T4B(i)=2*ntot*sum(Div);
     
  else 
   T4(i)=2*ntot*(sum((Pest.^(land+1))./PTH(:,i).^land)-1)/(land*(land+1)); 
     T4B(i)=2*ntot*(sum((Pest.^(land+1))./PTH(:,i).^land)-1)/(land*(land+1)); 
   end;
end;


 