%Ejemplo resuelto para los datos de Cohen con 3 variables
%para el clculo del error cuadrtico medio
%cometido en la estimacin del parmetro theta mediante fi estimadores.
%valores del ejemplo
%MAY  H NO 8
%MAY H SI  22
%MAY  M NO 29
%MAY M SI  12
%MEN H NO 7
%MEN H SI 21
% MEN M NO 23
%MEN M SI 20
M=8;
 N=71;
 n=2;
  pm=zeros(N,M);
% verdadero valor del parmetro obtenido previamente con sas mediante mxima
% verosimilitud
TH0=[0.0209;-0.2385; 0.0754; -0.1445; 0.1261;-0.3941];
% Matriz del modelo loglineal con interacin de orden 2( no saturado)
W=[ 1	1	1	1	1	1;
1	1	1	-1	-1	-1;
1	-1	-1	1	1	-1;
1	-1	-1	-1	-1	1;
-1	1	-1	1	-1	1;
-1	1	-1	-1	1	-1;
-1	-1	1	1	-1	-1;
-1	-1	1	-1	1	1 ]; 
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
den=sum(exp(W*TH0));
vp=(exp(W*TH0))/den;
M=length(vp);
M0=length(TH0);

 %La matriz DAT2 contiene las variables Y para cada individuo de cada cluster
  %Las categorias de las columnas son MSH MSM MNH MNM mSH mSM mNH	mNM (Edad= (M,m)
  %ESquizofrenia=(S,N) Sexo(M,H)
  %Sus correspondientes probabilidades son p111, p112, p121,p122, p211, p212, p221,p222 
 Pest=(sum(DAT2,1)./(n*N))';
 
mse=zeros(1,5);
TH=zeros(M0,5);
PTH=zeros(M,5);
 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro  
X0 = TH0;
X0(1) = TH0(1)+0.5;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end
   fidiv=@(x)(sum((Pest.^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
fidiv0=@(x)(Pest)'*log(Pest./((exp(W*x))/sum(exp(W*x))));
fidiv1=@(x)((exp(W*x))/sum(exp(W*x)))'*log((exp(W*x))/sum(exp(W*x))./(Pest));

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i)= fmincon(fidiv0,X0,[],[],[],[],[],[],restri,options);
  elseif land==-1
   TH(:,i)= fmincon(fidiv1,X0,[],[],[],[],[],[],restri,options);     
  else
    TH(:,i)= fmincon(fidiv,X0,[],[],[],[],[],[],restri,options);
 end; 
PTH(:,i)= (exp(W*TH(:,i)))/sum(exp(W*TH(:,i)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(1,i)=(TH(:,i)-TH0)'*(TH(:,i)-TH0)/M0;
end;
 
