%Ejemplo de grado de acuerdo entre el diagnstico de dos neurlogos. Agresti ejericio 10.11
% Aparecen 2 clusters  de tamao diferente
% MODELO 4 COMPLETO
%Clculo del estimador del coeficiente de sobredispersin y ro
%Tabla de contingencia con los diagnstiocs 1=Seguro, 2=Probable 3=Posible y 4= dudoso o nulo
% Los neurlogos son de New Orelans y de Winnipeg (NO,W)y los clusters son
% pacientes de Winnipeg= Cluster 1 y pacientes de NO cluster 2
Y=[ 38 5 0 1 33 11 3 0 10 14 5 6 3 7 3 10;
    5 3 0 0 3 11 4 0 2 13 3 4 1 2 4 14];

%Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global  W  TH0  M M0  Pest;
  clear W  TH0  M M0  Pest;
 
[N, M] = size(Y);
%N= numero de tamaos diferentes para los cluster=numero declustres porque
%estamos en el caso de todos los tamaos diferentes
%Tamaos de cada cluster 
nl=sum(Y,2)';

%nmero total de individuos
  ntot=sum(nl);
 
 %Inicializamos las Probabilidades para cada cluster 
  Pestl=zeros(size(Y,2),N);
  %Frecuencias relativas por cluster
 for l=1:N
 Pestl(:,l)=(Y(l,:)./nl(l))';
 end;
 % Probabilidad global sin distringuir clusters
 Pest=sum(Y,1)'./ntot;
 Pmed=sum(Pestl,2)./N;
  nmed=ntot/N;
 
  %Calculamos los estimadores de rowh de weir y ron, el introducido en el
 %artculo 

 ETA=(ntot^2-nl*nl')/((N-1)*ntot);
 
 MSP=(((Pestl-(repmat(Pest,1,N))).^2)*nl')./(N-1);
 MSG=((Pestl-(Pestl).^2)*nl')./(ntot-N);
rowh=(sum(MSP-MSG))/(sum(MSP+(MSG.*(ETA-1))));
Nuw=1+(nmed-1)*rowh;
for r=1:M
    if Pest(r)==0
        ronsum(r)=0;
    else
ronsum(r)= sum(((Pestl(r,:)-repmat(Pmed(r),1,N)).^2)*(Pest(r)^(-1)));
    end;
end;
ron=sum(ronsum)/((N-1)*(M-1));
Nu=1+(nmed-1)*ron;
  
% verdadero valor del parmetro utilizado como valor inicial
TH0 =[0.5 ; 2.05; 1.16; -0.43 ; 3.55; 1.60; -1.55; 0.76 ];
% Matriz del modelo loglineal landa+landaA(1,2,3)+landaB(1,2,3)+delta(acuerdo) SIN LA TRIPLE  interacin (MODELO (2)
 
  W =[1  1  0  0  1  0  0  1; 
     1  1  0  0  0  1  0  2; 
     1  1  0  0  0  0  1  3;
     1  1  0  0 -1 -1 -1  4 ; 
     1  0  1  0  1  0  0  2;
     1  0  1  0  0  1  0  4; 
     1  0  1  0  0  0  1  6; 
     1  0  1  0 -1 -1 -1  8;
     1  0  0  1  1  0  0  3; 
     1  0  0  1  0  1  0  6; 
     1  0  0  1  0  0  1  9; 
     1  0  0  1 -1 -1 -1  12;
     1 -1 -1 -1  1  0  0  4;
     1 -1 -1 -1  0  1  0  8; 
     1 -1 -1 -1  0  0  1  12; 
     1 -1 -1 -1 -1 -1 -1  16];
 
 
 
M0=size(W,2);


%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro

%Vectores de probabilidad estimados mediante modelo loglineal
PTH0=zeros(M,1);
PTH0=exp(W*TH0)/sum(exp(W*TH0));
%Inicializamos las matrices que van a contener las probabilidades estimadas
%y los estimadores de ro

TH=zeros(M0,5);
PTH=zeros(M,5);
SE=zeros(M,5);
 mse=zeros(1,5);


 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro 
X0 = TH0;
X0(1) = TH0(1)+0.05; 

 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
   fiDiv=@(x)(sum((Pest.^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
   fiDiv0=@(x)fidiv0(Pest,x,W);
  

 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 

 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i)= fmincon(fiDiv0,X0,[],[],[],[],[],[],restri,options);
  
  else
    TH(:,i)= fmincon(fiDiv,X0,[],[],[],[],[],[],restri,options);
     
 end; 
PTH(:,i)= (exp(W*TH(:,i)))/sum(exp(W*TH(:,i)));

%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
   mse(1,i)=(PTH(:,i)-Pest)'*(PTH(:,i)-Pest)/M;
   
    % Calculamos el estimador del coeficiente de correlacin intracluster y
  % el coeficiente de sobredispersin segn los dos modelos loglineales
    for m=1:M
       if Pest(m)==0
           ronsum(m)=0;
            ronsum1(m)=0;
         else
          ronsum(m)= sum(((Pestl(m,:)-repmat(Pmed(m),1,N)).^2)*(PTH(m,i)^(-1))); 
          
       end;
    end;
   ronfi(i)=sum(ronsum)/((N-1)*(M-1));
      Nufi(i)=1+(nmed-1)*ronfi(i);
end;  
for j=1:5
  for i=1:5
    if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
    if land==0 
     for m=1:M
       if Pest(m)==0
          Div(m)=0;
       else
        Div(m)=Pest(m)*log(Pest(m)/PTH(m,i));
       end;
     end;
      
      T(i,j)=2*ntot*sum(Div);
      TB(i,j)=2*ntot*sum(Div)/Nufi(j);
    else
      T(i,j)=2*ntot*(sum((Pest.^(land+1))./PTH(:,j).^land)-1)/(land*(land+1)); 
     TB(i,j)=2*ntot*(sum((Pest.^(land+1))./PTH(:,j).^land)-1)/(land*(land+1))/Nufi(j);
      end;
 %Observemos que corregimos con el factor de sobredispersin Nu calculado bajo la hiptesis nula 
 pvalor_T(i,j)= 1-chi2cdf(T(i,j),M-M0);
  pvalor_TB(i,j)= 1-chi2cdf(TB(i,j),M-M0);
  end;
end;

     