%Simulacin  para el clculo de los niveles de significacin  
%para el contraste de bondad de ajuste para tamaos de cluster constantes
%el tamao del cluster y para diferentes modelos degrado de acuerdo Es
%decir Contrastes: H nula: M3 H alternativa M2, H nula: M3 H alternativa
%M2*, H nula: M2 H alternativa M1
n=10;
%nmero total de clusters
 TC=71;
 ntot=n*TC;

%Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global ro2 W W1 TH0 TH01 M M0 M01 Pest;
  clear ro2 W W1 TH0 TH01 M M0 M01 Pest;

 %nmero de muestras a generar
N=100;

 % verdadero valor del parmetro utilizado como valor inicial
TH0 =[0.5612 ; 1.9834; 1.1512; -0.4032 ; 3.5075; 1.5843; -1.5419; 0.0005];

% Matriz del modelo loglineal landa+landaA1,2,3+landaB1,2,3+delta(acuerdo) SIN LA TRIPLE  interacin (MODELO (2)
 W =[1  1  0  0  1  0  0 1; 
     1  1  0  0  0  1  0 2; 
     1  1  0  0  0  0  1 3;
     1  1  0  0 -1 -1 -1 4; 
     1  0  1  0  1  0  0 2;
     1  0  1  0  0  1  0 4; 
     1  0  1  0  0  0  1 6; 
     1  0  1  0 -1 -1 -1 8;
     1  0  0  1  1  0  0 3; 
     1  0  0  1  0  1  0 6; 
     1  0  0  1  0  0  1 9; 
     1  0  0  1 -1 -1 -1 12;
     1 -1 -1 -1  1  0  0 4;
     1 -1 -1 -1  0  1  0 8; 
     1 -1 -1 -1  0  0  1 12 ; 
     1 -1 -1 -1 -1 -1 -1 16]; 
 
 TH01 =[0.5612 ; 1.9834; 1.1512; -0.4032 ; 3.5075; 1.5843; -1.5419; 0.0005;0.7285 ];
%
 % Matriz del modelo loglineal
 % landa+landaA1,2,3+landaB1,2,3+delta(acuerdo)+Beta por u i*j
 W1 =[1  1  0  0  1  0  0 1 1; 
     1  1  0  0  0  1  0 0 2; 
     1  1  0  0  0  0  1 0 3;
     1  1  0  0 -1 -1 -1 0 4 ; 
     1  0  1  0  1  0  0 0 2;
     1  0  1  0  0  1  0 1 4; 
     1  0  1  0  0  0  1 0 6; 
     1  0  1  0 -1 -1 -1 0 8;
     1  0  0  1  1  0  0 0 3; 
     1  0  0  1  0  1  0 0 6; 
     1  0  0  1  0  0  1 1 9; 
     1  0  0  1 -1 -1 -1 0 12;
     1 -1 -1 -1  1  0  0 0 4;
     1 -1 -1 -1  0  1  0 0 8; 
     1 -1 -1 -1  0  0  1 0 12; 
     1 -1 -1 -1 -1 -1 -1 1 16];

 [M,M0] = size(W);
M01=size(W1,2);

%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro

%Vectores de probabilidad estimados mediante modelo loglineal
PTH0=zeros(M,1);
PTH0=exp(W*TH0)/sum(exp(W*TH0));
PTH01=zeros(M,1);
PTH01=exp(W1*TH01)/sum(exp(W1*TH01));
%Inicializamos las matrices que van a contener las probabilidades estimadas
%y los estimadores de ro
Pest=zeros(M,N);
TH=zeros(M0,5,N);
PTH=zeros(M,5,N);
TH1=zeros(M01,5,N);
PTH1=zeros(M,5,N);

ChiTH=zeros(TC,M,5);
ChiN=zeros(TC,M);
T=zeros(5,5);
TB=zeros(5,5);
TSC=zeros(5,5);
Nu=zeros(1,6);
alfaT=zeros(5,5,39);
alfaTB=zeros(5,5,39);
alfaTSC=zeros(5,5,39);
IalfaT=zeros(5,5);
IalfaTB=zeros(5,5);
IalfaTSC=zeros(5,5);
sumalfaT=zeros(5,5,39);
sumalfaTB=zeros(5,5,39);
sumalfaTSC=zeros(5,5,39);
alfaT2=zeros(5,5,39);
alfaTB2=zeros(5,5,39);
alfaTSC2=zeros(5,5,39);
IalfaT2=zeros(5,5);
IalfaTB2=zeros(5,5);
IalfaTSC2=zeros(5,5);
sumalfaT2=zeros(5,5,39);
sumalfaTB2=zeros(5,5,39);
sumalfaTSC2=zeros(5,5,39);


 % El valor inicial para el algoritmo de optimizacin es el valor terico del parmetro 
X0 = TH0;
X0(1) = TH0(1)+0.05; 
X01 = TH01;
X01(1) = TH01(1)+0.05;
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
 for r=1:39
     ro2=2.5*r/100;
   a=PTH0*(1-ro2)/ro2; 
%generamos N muestras formadas por clusters de tamao n utilizando
%comodistribucin deprobabilidad la del modelo de la hiptesis nula, de
%forma que la frecuencia de rechazos de la hipotesis es una estimacin de
%alfa
for h=1:N
    ArDat=zeros(TC,M); %valores simulados
      pm=zeros(TC,M); %Probabilidades empricas para cada cluster
     %generamos los vectores de probabilidad mediante dirichlet de parmetros
   %a y PTH0 y partir de aqu las multinomiales con dichos vectores
    %Observemos que cada fila de ArDat es una muestra de valores de un cluster
  for l=1:TC 
       ArDat(l,:)=Dirnd(ro2,a,n);
     %Calculamos el vector de probabilidad estimado para cada cluster pm  
       pm(l,:)=ArDat(l,:)/n;
  end; 
  Pest(:,h)=sum(ArDat,1)'./ntot;
    for r=1:M
    if Pest(r,h)==0;
        Pest(r,h)=0.000001;
    end;
   end;
  %Para cada una de las muestras calculamos el estimador de mnima
 %fi-divergencia  para los siguientes valores de landa y el estimador de ro

for i=1:5
     if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
   fiDiv=@(x)(sum((Pest(:,h).^(land+1))./((exp(W*x)/sum(exp(W*x))).^land)-1)/(land*(land+1)));
   fiDiv0=@(x)((Pest(:,h))'*log(Pest(:,h)./((exp(W*x))/sum(exp(W*x)))));
  
 c=@(x)[(exp(W*x))/sum(exp(W*x))-1;
     -(exp(W*x))/sum(exp(W*x))];
 ceq =@(x)[];
 restri=@(x)deal(c(x),ceq(x));
 
 
 fiDiv_1=@(x)(sum((Pest(:,h).^(land+1))./((exp(W1*x)/sum(exp(W1*x))).^land)-1)/(land*(land+1)));
   fiDiv0_1=@(x)((Pest(:,h))'*log(Pest(:,h)./((exp(W1*x))/sum(exp(W1*x)))));
 
 c1=@(x)[(exp(W1*x))/sum(exp(W1*x))-1;
     -(exp(W1*x))/sum(exp(W1*x))];
 ceq =@(x)[];
 restri1=@(x)deal(c1(x),ceq(x));
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH(:,i,h)= fmincon(fiDiv0,X0,[],[],[],[],[],[],restri,options);
  TH1(:,i,h)= fmincon(fiDiv0_1,X01,[],[],[],[],[],[],restri1,options);
  
  else
    TH(:,i,h)= fmincon(fiDiv,X0,[],[],[],[],[],[],restri,options);
     TH1(:,i,h)= fmincon(fiDiv_1,X01,[],[],[],[],[],[],restri1,options);
 end;
 ODS(i)=exp(2*TH(M0,i,h));
PTH(:,i,h)= (exp(W*TH(:,i,h)))/sum(exp(W*TH(:,i,h)));
PTH1(:,i,h)= (exp(W1*TH1(:,i,h)))/sum(exp(W1*TH1(:,i,h)));
%CAlculamos el error cuadrtico medio cometido en la estimacin en cada muestra
  mse(1,i)=(PTH(:,i,h)-Pest(:,h))'*(PTH(:,i,h)-Pest(:,h))/M;
   mse(2,i)=(PTH1(:,i,h)-Pest(:,h))'*(PTH1(:,i,h)-Pest(:,h))/M;
    % Calculamos el estimador del coeficiente de correlacin intracluster y
  % el coeficiente de sobredispersin segn los dos modelos loglineales
    for l=1:TC 
         Difv(l,:)= ((pm(l,:)-Pest(:,h)')).^2;
    end;
end;
   % Para evitar la divisin por cero sustituimos el sumando por su valor
for j=1:5
   for m=1:M 
       if PTH(m,j,h)==0
             ChiTH(l,m,j)=0;   
       else
          ChiTH(l,m,j)=Difv(l,m)/PTH(m,j,h);
       end;
       if Pest(m,h)==0
             ChiN(l,m)=0;
        else
            ChiN(l,m)=Difv(l,m)/Pest(m,h);
        end;  
    end;
 %Con la probabilidad estimada mediante el modelo loglineal y los estimadores de m fi-divergencia
%calculamos el estimador de ro para cada uno de los valores de landa
    %Sumamos desde j=1 hasta M
  Nu(1)=(sum(sum(ChiN))*n)/((TC-1)*(M-1));
  Nu(j+1)=(sum(sum(ChiTH(:,:,j)))*n)/((TC-1)*(M-1));
  
  end;

%Clculo de los estadsticos para el contraste de hiptesis anidadas
 %Observemos que Fi1 viene dado por filas y Fi2 (utilizada para obtener el
 %estimador) viene por columnas y el coeficiente Nu es estimado con Fi2 
 %
for j=1:5
  for i=1:5
       if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end;
    if land==0; 
     for m=1:M;
      if PTH(m,j,h)==0;
          Div(m)=0;
         else
        Div(m)=PTH(m,j,h)*log(PTH(m,j,h)/PTH1(m,j,h));
       end;
     end;
      T(i,j)=2*ntot*sum(Div);
      TB(i,j)=2*ntot*sum(Div)/Nu(j+1);   
    else
      T(i,j)=2*ntot*(sum((PTH(:,j,h).^(land+1))./PTH1(:,j,h).^land)-1)/(land*(land+1)); 
     TB(i,j)=2*ntot*(sum((PTH(:,j,h).^(land+1))./PTH1(:,j,h).^land)-1)/(land*(land+1))/Nu(j+1);
    end;
    
 
  if T(i,j)>chi2inv(0.95,M01-M0) 
      IalfaT(i,j)=1; else IalfaT(i,j)=0;end;
 sumalfaT(i,j,r)= sumalfaT(i,j,r)+IalfaT(i,j);
  if T(i,j)>chi2inv(0.90,M01-M0) 
      IalfaT2(i,j)=1; else IalfaT2(i,j)=0;end;
 sumalfaT2(i,j,r)= sumalfaT2(i,j,r)+IalfaT2(i,j);
 
 if TB(i,j)>chi2inv(0.95,M01-M0) 
     IalfaTB(i,j)=1; else IalfaTB(i,j)=0;end;
 sumalfaTB(i,j,r)= sumalfaTB(i,j,r)+IalfaTB(i,j);
 if TB(i,j)>chi2inv(0.90,M01-M0) 
     IalfaTB2(i,j)=1; else IalfaTB2(i,j)=0;end;
 sumalfaTB2(i,j,r)= sumalfaTB2(i,j,r)+IalfaTB2(i,j);
 
 if TSC(i,j)>chi2inv(0.95,M01-M0) 
     IalfaT(i,j)=1; else IalfaT(i,j)=0;end;
 sumalfaTSC(i,j,r)= sumalfaTSC(i,j,r)+IalfaT(i,j);
 
 if TSC(i,j)>chi2inv(0.90,M01-M0) 
     IalfaT2(i,j)=1; else IalfaT2(i,j)=0;end;
 sumalfaTSC2(i,j,r)= sumalfaTSC2(i,j,r)+IalfaT2(i,j);
 
 alfaT(i,j,r)=sumalfaT(i,j,r)/N;
  alfaTB(i,j,r)=sumalfaTB(i,j,r)/N;
 alfaTSC(i,j,r)=sumalfaTSC(i,j,r)/N; 
 alfaT2(i,j,r)=sumalfaT2(i,j,r)/N;
  alfaTB2(i,j,r)=sumalfaTB2(i,j,r)/N;
 alfaTSC2(i,j,r)=sumalfaTSC2(i,j,r)/N; 
 
 end;
end;
end;
end;
