%Simulacin  para el clculo de los niveles de significacin  
%para el contraste de bondad de ajuste para tamaos de cluster constantes
%el tamao del cluster y para diferentes modelos degrado de acuerdo Es
%decir Contrastes: H nula: M3 H alternativa M2, H nula: M3 H alternativa
%M2*, H nula: M2 H alternativa M1
n=40;
%nmero total de clusters
 TC=20;
 ntot=n*TC;

%Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global ro2 W1 W2 W2B W3  TH01  M M01 M02 M02B M03 Pest;
  clear ro2 W1 W2 W2B W3 TH01 M M01 M02 M02B M03 Pest;

 %nmero de muestras a generar
N=10;
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
  % Matrices de los diferentes modelos loglineales 
  
 % Modelo 1: Completo: landa+landaA1,2,3+landaB1,2,3+delta(acuerdo)+Beta por u i*j
 
 W1 =[1  1  0  0  1  0  0 1 1; 
     1  1  0  0  0  1  0 0 2; 
     1  1  0  0  0  0  1 0 3;
     1  1  0  0 -1 -1 -1 0 4 ; 
     1  0  1  0  1  0  0 0 2;
     1  0  1  0  0  1  0 1 4; 
     1  0  1  0  0  0  1 0 6; 
     1  0  1  0 -1 -1 -1 0 8;
     1  0  0  1  1  0  0 0 3; 
     1  0  0  1  0  1  0 0 6; 
     1  0  0  1  0  0  1 1 9; 
     1  0  0  1 -1 -1 -1 0 12;
     1 -1 -1 -1  1  0  0 0 4;
     1 -1 -1 -1  0  1  0 0 8; 
     1 -1 -1 -1  0  0  1 0 12; 
     1 -1 -1 -1 -1 -1 -1 1 16];

 
% Matriz del modelo loglineal landa+landaA1,2,3+landaB1,2,3+ medida de acuerdo para variables ordinales (MODELO (2)
 W2 =[1  1  0  0  1  0  0 1; 
     1  1  0  0  0  1  0 2; 
     1  1  0  0  0  0  1 3;
     1  1  0  0 -1 -1 -1 4; 
     1  0  1  0  1  0  0 2;
     1  0  1  0  0  1  0 4; 
     1  0  1  0  0  0  1 6; 
     1  0  1  0 -1 -1 -1 8;
     1  0  0  1  1  0  0 3; 
     1  0  0  1  0  1  0 6; 
     1  0  0  1  0  0  1 9; 
     1  0  0  1 -1 -1 -1 12;
     1 -1 -1 -1  1  0  0 4;
     1 -1 -1 -1  0  1  0 8; 
     1 -1 -1 -1  0  0  1 12 ; 
     1 -1 -1 -1 -1 -1 -1 16]; 
 % Matriz del modelo loglineal landa+landaA(1,2,3)+landaB(1,2,3)+delta(acuerdo soloen la diagonal)  (MODELO 3(2*)

  W2B =[1  1  0  0  1  0  0 1; 
     1  1  0  0  0  1  0 0; 
     1  1  0  0  0  0  1 0;
     1  1  0  0 -1 -1 -1 0; 
     1  0  1  0  1  0  0 0;
     1  0  1  0  0  1  0 1; 
     1  0  1  0  0  0  1 0; 
     1  0  1  0 -1 -1 -1 0;
     1  0  0  1  1  0  0 0; 
     1  0  0  1  0  1  0 0; 
     1  0  0  1  0  0  1 1; 
     1  0  0  1 -1 -1 -1 0;
     1 -1 -1 -1  1  0  0 0;
     1 -1 -1 -1  0  1  0 0; 
     1 -1 -1 -1  0  0  1 0 ; 
     1 -1 -1 -1 -1 -1 -1 1]; 
%Matriz del modelo loglineal landa+landaA(1,2,3)+landaB(1,2,3)(Modelo 4:independencia)
 
 W3 =[1  1  0  0  1  0  0 ; 
     1  1  0  0  0  1  0 ; 
     1  1  0  0  0  0  1 ;
     1  1  0  0 -1 -1 -1 ; 
     1  0  1  0  1  0  0 ;
     1  0  1  0  0  1  0; 
     1  0  1  0  0  0  1 ; 
     1  0  1  0 -1 -1 -1 ;
     1  0  0  1  1  0  0 ; 
     1  0  0  1  0  1  0 ; 
     1  0  0  1  0  0  1 ; 
     1  0  0  1 -1 -1 -1 ;
     1 -1 -1 -1  1  0  0 ;
     1 -1 -1 -1  0  1  0; 
     1 -1 -1 -1  0  0  1  ; 
     1 -1 -1 -1 -1 -1 -1 ]; 

 [M,M01] = size(W1);
M02=size(W2,2);
M02B=size(W2B,2);
M03=size(W3,2);
 

%Inicializamos las matrices que van a contener las probabilidades estimadas
%Vectores de probabilidad estimados mediante modelo loglineal
PTH1=zeros(M,1);
TH1=zeros(M01,1);
PTH2=zeros(M,1);
TH2=zeros(M02,1);
PTH2B=zeros(M,1);
TH2B=zeros(M02B,1);
PTH3=zeros(M,1);
TH3=zeros(M03,1);

Pest=zeros(M,1);

%y los estimadores de ro

ChiTH=zeros(TC,M,5);
ChiN=zeros(TC,M);
T21=zeros(5,5);
T2B1=zeros(5,5);
T32=zeros(5,5);
T32B=zeros(5,5);
TB21=zeros(5,5);
TB2B1=zeros(5,5);
TB32=zeros(5,5);
TB32B=zeros(5,5);
Nu2=zeros(1,6);
Nu2B=zeros(1,6);
Nu3=zeros(1,6);
% Indicadores de resultados de los contrastes jerrquicos
% Para los contrastes corregidos por el efecto del diseo
IMOD1=zeros(5,5,39);IMOD2=zeros(5,5,39);IMOD3=zeros(5,5,39);IMOD4=zeros(5,5,39);
SMOD1=zeros(5,5,39);SMOD2=zeros(5,5,39);SMOD3=zeros(5,5,39);SMOD4=zeros(5,5,39);
MOD1=zeros(5,5,39);MOD2=zeros(5,5,39);MOD3=zeros(5,5,39);MOD4=zeros(5,5,39);
% Para los contrastes sin corregir
IM1=zeros(5,5,39);IM2=zeros(5,5,39);IM3=zeros(5,5,39);IM4=zeros(5,5,39);
SM1=zeros(5,5,39);SM2=zeros(5,5,39);SM3=zeros(5,5,39);SM4=zeros(5,5,39);
M1=zeros(5,5,39);M2=zeros(5,5,39);M3=zeros(5,5,39);M4=zeros(5,5,39);

 % El valor inicial DEL VECTOR DE PROBABILIDAD QUE DESCRIBE LOS DIFERNTES PODIBLES MODELOS DE ACUERDO 
 
TH03 =[0.5521 ; 0.012; 0.1274; -0.0254 ; 0.655; 0.2473; -0.7875]; X03= TH03; X03(1) = TH03(1)+0.05;
 TH02 =[0.6312 ; 2.0834; 1.1512; -0.4032 ; 3.5075; 1.5843; -1.5419; 0.7865 ];X02= TH02; X02(1) = TH02(1)+0.05;
 TH02B =[0.5 ; -0.04; 0.19; 0.05 ; 0.70; 0.34; -0.75; 0.06 ]; X02B= TH02B; X02B(1) = TH02B(1)+0.05;
  TH01 =[0.5612 ; 1.9834; 1.1512; -0.4032 ; 3.5075; 1.5843; -1.5419; 0.0645;0.7285 ]; 
  X01= TH01; X01(1) = TH01(1)+0.05;
  
PTH01= (exp(W1*TH01))/sum(exp(W1*TH01));
PTH02= (exp(W2*TH02))/sum(exp(W2*TH02));
PTH02B= (exp(W2B*TH02B))/sum(exp(W2B*TH02B));
PTH03= (exp(W3*TH03))/sum(exp(W3*TH03));
%Escogemos el vector de probabilidad para generar los datos suponiendo que el modelo loglineal 
%que verifican los datos es 
PTH0=PTH02; 
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
 for r=1:39
     ro2=2.5*r/100;
   a=PTH0*(1-ro2)/ro2; 
%generamos N muestras formadas por clusters de tamao n utilizando
%comodistribucin deprobabilidad la del modelo de la hiptesis nula, de
%forma que la frecuencia de rechazos de la hipotesis es una estimacin de
%alfa
for h=1:N
      ArDat=zeros(TC,M); %valores simulados
      pm=zeros(TC,M); %Probabilidades empricas para cada cluster
     %generamos los vectores de probabilidad mediante dirichlet de parmetros
   %a y PTH0 y partir de aqu las multinomiales con dichos vectores
    %Observemos que cada fila de ArDat es una muestra de valores de un cluster
  for l=1:TC 
       ArDat(l,:)=Dirnd(ro2,a,n);
     %Calculamos el vector de probabilidad estimado para cada cluster pm  
       pm(l,:)=ArDat(l,:)/n;
  end; 
  Pest=sum(ArDat,1)'./ntot;
   
    for m=1:M
    if Pest(m)==0;
        Pest(m)=0.000001;
    end;
   end;
   
  for l=1:TC 
         Difv(l,:)= ((pm(l,:)-Pest')).^2;
    end;  
   
  %Para cada una de las muestras calculamos el estimador de mnima
 %fi-divergencia  para los siguientes valores de landa y el estimador de ro

for i=1:5
     if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end; 
   
    fiDiv_3=@(x)(sum((Pest.^(land+1))./((exp(W3*x)/sum(exp(W3*x))).^land)-1)/(land*(land+1)));
   fiDiv0_3=@(x)(Pest'*log(Pest./(exp(W3*x)/sum(exp(W3*x)))));
  
 c=@(x)[(exp(W3*x))/sum(exp(W3*x))-1;
     -(exp(W3*x))/sum(exp(W3*x))];
 ceq =@(x)[];
 restri3=@(x)deal(c(x),ceq(x));
 
     fiDiv_2B=@(x)(sum((Pest.^(land+1))./((exp(W2B*x)/sum(exp(W2B*x))).^land)-1)/(land*(land+1)));
   fiDiv0_2B=@(x)(Pest'*log(Pest./(exp(W2B*x)/sum(exp(W2B*x)))));
  
 c=@(x)[(exp(W2B*x))/sum(exp(W2B*x))-1;
     -(exp(W2B*x))/sum(exp(W2B*x))];
 ceq =@(x)[];
 restri2B=@(x)deal(c(x),ceq(x));
    
   
    
   fiDiv_2=@(x)(sum((Pest.^(land+1))./((exp(W2*x)/sum(exp(W2*x))).^land)-1)/(land*(land+1)));
   fiDiv0_2=@(x)(Pest'*log(Pest./(exp(W2*x)/sum(exp(W2*x)))));
  
  c=@(x)[(exp(W2*x))/sum(exp(W2*x))-1;
     -(exp(W2*x))/sum(exp(W2*x))];
 ceq =@(x)[];
 restri2=@(x)deal(c(x),ceq(x));
 
 
 fiDiv_1=@(x)(sum((Pest.^(land+1))./((exp(W1*x)/sum(exp(W1*x))).^land)-1)/(land*(land+1)));
   fiDiv0_1=@(x)(Pest'*log(Pest./((exp(W1*x))/sum(exp(W1*x)))));
 
 c1=@(x)[(exp(W1*x))/sum(exp(W1*x))-1;
     -(exp(W1*x))/sum(exp(W1*x))];
 ceq =@(x)[];
 restri1=@(x)deal(c1(x),ceq(x));
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH1(:,i)= fmincon(fiDiv0_1,X01,[],[],[],[],[],[],restri1,options);
  TH2(:,i)= fmincon(fiDiv0_2,X02,[],[],[],[],[],[],restri2,options);
   TH2B(:,i)= fmincon(fiDiv0_2B,X02B,[],[],[],[],[],[],restri2B,options);
   TH3(:,i)= fmincon(fiDiv0_3,X03,[],[],[],[],[],[],restri3,options);
  
  else
  TH1(:,i)= fmincon(fiDiv_1,X01,[],[],[],[],[],[],restri1,options);
  TH2(:,i)= fmincon(fiDiv_2,X02,[],[],[],[],[],[],restri2,options);
   TH2B(:,i)= fmincon(fiDiv_2B,X02B,[],[],[],[],[],[],restri2B,options);
   TH3(:,i)= fmincon(fiDiv_3,X03,[],[],[],[],[],[],restri3,options);
 end;

PTH1(:,i)= (exp(W1*TH1(:,i)))/sum(exp(W1*TH1(:,i)));
PTH2(:,i)= (exp(W2*TH2(:,i)))/sum(exp(W2*TH2(:,i)));
PTH2B(:,i)= (exp(W2B*TH2B(:,i)))/sum(exp(W2B*TH2B(:,i)));
PTH3(:,i)= (exp(W3*TH3(:,i)))/sum(exp(W3*TH3(:,i)));
 
   % Calculamos el estimador del coeficiente de correlacin intracluster y
  % el coeficiente de sobredispersin segn los dos modelos loglineales
    

   % Para evitar la divisin por cero sustituimos el sumando por su valor
   for l=1:TC 
     for m=1:M 
       if PTH1(m,i)==0 ChiTH1(l,m,i)=0;   
       else ChiTH1(l,m,i)=Difv(l,m)/PTH1(m,i);
       end;
       if PTH2(m,i)==0  ChiTH2(l,m,i)=0;   
       else  ChiTH2(l,m,i)=Difv(l,m)/PTH1(m,i);
       end;
       if PTH2B(m,i)==0 ChiTH2B(l,m,i)=0;   
       else  ChiTH2B(l,m,i)=Difv(l,m)/PTH2B(m,i);
       end;
       if PTH3(m,i)==0 ChiTH3(l,m,i)=0;   
       else  ChiTH3(l,m,i)=Difv(l,m)/PTH3(m,i);
       end;
         ChiN(l,m)=Difv(l,m)/Pest(m);
     end;  
    end;
 %Con la probabilidad estimada mediante el modelo loglineal y los estimadores de m fi-divergencia
%calculamos el estimador de ro para cada uno de los valores de landa
    %Sumamos desde j=1 hasta M
  Nu(1)=(sum(sum(ChiN))*n)/((TC-1)*(M-1));
  Nu1(i+1)=(sum(sum(ChiTH1(:,:,i)))*n)/((TC-1)*(M-1));
  Nu2(i+1)=(sum(sum(ChiTH2(:,:,i)))*n)/((TC-1)*(M-1));
  Nu2B(i+1)=(sum(sum(ChiTH2B(:,:,i)))*n)/((TC-1)*(M-1));
  Nu3(i+1)=(sum(sum(ChiTH3(:,:,i)))*n)/((TC-1)*(M-1));
  
end;

%Clculo de los estadsticos para el contraste de hiptesis anidadas
 %Observemos que Fi1 viene dado por filas y Fi2 (utilizada para obtener el
 %estimador) viene por columnas y el coeficiente Nu es estimado con Fi2 
 %
for j=1:5
  for i=1:5
       if i==1 land=-0.5; 
       elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
       else land=2;
      end;
   if land==0; 
     for m=1:M;
      if PTH1(m,j)==0  Div12(m)=0;
      else  Div12(m,j)=PTH1(m,j)*log(PTH1(m,j)/PTH2(m,j));
       end;
       if PTH1(m,j)==0  Div12B(m)=0;
      else  Div12B(m,j)=PTH1(m,j)*log(PTH1(m,j)/PTH2B(m,j));
       end;
       if PTH2(m,j)==0  Div23(m)=0;
      else  Div23(m,j)=PTH2(m,j)*log(PTH2(m,j)/PTH3(m,j));
       end;
       if PTH2B(m,j)==0  Div2B3(m)=0;
      else  Div2B3(m,j)=PTH2B(m,j)*log(PTH2B(m,j)/PTH3(m,j));
       end;
     end;
      T21(i,j)=2*ntot*sum(Div12(:,j));
      T2B1(i,j)=2*ntot*sum(Div12B(:,j));
      T32(i,j)=2*ntot*sum(Div23(:,j)); 
      T32B(i,j)=2*ntot*sum(Div2B3(:,j));
      
      TB21(i,j)=2*ntot*sum(Div12(:,j))/Nu2(j+1);
      TB2B1(i,j)=2*ntot*sum(Div12B(:,j))/Nu2B(j+1);
      TB32(i,j)=2*ntot*sum(Div23(:,j))/Nu3(j+1);
      TB32B(i,j)=2*ntot*sum(Div2B3(:,j))/Nu3(j+1);
      
    else
      T21(i,j)=2*ntot*(sum((PTH1(:,j).^(land+1))./PTH2(:,j).^land)-1)/(land*(land+1)); 
      T2B1(i,j)=2*ntot*(sum((PTH1(:,j).^(land+1))./PTH2B(:,j).^land)-1)/(land*(land+1));
      T32(i,j)=2*ntot*(sum((PTH2(:,j).^(land+1))./PTH3(:,j).^land)-1)/(land*(land+1));
      T32B(i,j)=2*ntot*(sum((PTH2B(:,j).^(land+1))./PTH3(:,j).^land)-1)/(land*(land+1));
      
     TB21(i,j)=2*ntot*(sum((PTH1(:,j).^(land+1))./PTH2(:,j).^land)-1)/(land*(land+1))/Nu2(j+1);
       TB2B1(i,j)=2*ntot*(sum((PTH1(:,j).^(land+1))./PTH2B(:,j).^land)-1)/(land*(land+1))/Nu2B(j+1);
       TB32(i,j)=2*ntot*(sum((PTH2(:,j).^(land+1))./PTH3(:,j).^land)-1)/(land*(land+1))/Nu3(j+1);
       TB32B(i,j)=2*ntot*(sum((PTH2B(:,j).^(land+1))./PTH3(:,j).^land)-1)/(land*(land+1))/Nu3(j+1);
    end;
    % se reslizan los contrastes jerrquicos en los dos caminos posibles
    % con el modelo de acuerdo solo en la diagonal (2B) o con el modelo de
    % acuerdo para valores ordinales (M2)
    
 %Utilizando el estadstico corregido 
  if TB21(i,j)>chi2inv(0.95,M01-M02)  IMOD1(i,j,r)=1;
  else 
      IMOD2(i,j,r)=1;
      if TB32(i,j)>chi2inv(0.95,M02-M03) IMOD2(i,j,r)=1; 
      else  IMOD4(i,j,r)=1; IMOD2(i,j,r)=0;
      end;
  end;
  if TB2B1(i,j)>chi2inv(0.95,M01-M02B) IMOD1(i,j,r)=1;
  else
      IMOD3(i,j,r)=1;
      if TB32B(i,j)>chi2inv(0.95,M02B-M03) IMOD3(i,j,r)=1;
      else  IMOD4(i,j,r)=1; IMOD3(i,j,r)=0;
      end;
  end;
   % Elegimos de las dos vias del modelo jerrquico la uqe haya llegado a un modelo ms sencillo
   if IMOD1(i,j,r)*IMOD2(i,j,r)>0 IMOD1(i,j,r)=0;end;
   if IMOD1(i,j,r)*IMOD3(i,j,r)>0 IMOD1(i,j,r)=0; end;    
  if IMOD1(i,j,r)*IMOD4(i,j,r)>0 IMOD1(i,j,r)=0; end;
     if IMOD2(i,j,r)*IMOD3(i,j,r)>0 IMOD2(i,j,r)=0.5; IMOD3(i,j,r)=0.5; end;
      
   SMOD1(i,j,r)= SMOD1(i,j,r)+IMOD1(i,j,r);
  SMOD2(i,j,r)= SMOD2(i,j,r)+IMOD2(i,j,r);
  SMOD3(i,j,r)= SMOD3(i,j,r)+IMOD3(i,j,r);
  SMOD4(i,j,r)= SMOD4(i,j,r)+IMOD4(i,j,r);
  
  
 MOD1(i,j,r)=SMOD1(i,j,r)/N;
  MOD2(i,j,r)=SMOD2(i,j,r)/N;
  MOD3(i,j,r)=SMOD3(i,j,r)/N; 
  MOD4(i,j,r)=SMOD4(i,j,r)/N; 
  
  %Utilizando el estadistico sin corregir
      
 %Utilizando el estadstico corregido 
  if T21(i,j)>chi2inv(0.95,M01-M02)  IM1(i,j,r)=1;
  else 
      IM2(i,j,r)=1;
      if T32(i,j)>chi2inv(0.95,M02-M03) IM2(i,j,r)=1; 
      else  IM4(i,j,r)=1; IM2(i,j,r)=0;
      end;
  end;
  if T2B1(i,j)>chi2inv(0.95,M01-M02B) IM1(i,j,r)=1;
  else
      IM3(i,j,r)=1;
      if T32B(i,j)>chi2inv(0.95,M02B-M03) IM3(i,j,r)=1;
      else  IM4(i,j,r)=1; IM3(i,j,r)=0;
      end;
  end;
   % Elegimos de las dos vias del modelo jerrquico la uqe haya llegado a un modelo ms sencillo
   if IM1(i,j,r)*IM2(i,j,r)>0 IM1(i,j,r)=0;end;
   if IM1(i,j,r)*IM3(i,j,r)>0 IM1(i,j,r)=0; end;    
  if IM1(i,j,r)*IM4(i,j,r)>0 IM1(i,j,r)=0; end;
     if IM2(i,j,r)*IM3(i,j,r)>0 IM2(i,j,r)=0.5; IM3(i,j,r)=0.5; end;
      
   SM1(i,j,r)= SM1(i,j,r)+IM1(i,j,r);
  SM2(i,j,r)= SM2(i,j,r)+IM2(i,j,r);
  SM3(i,j,r)= SM3(i,j,r)+IM3(i,j,r);
  SM4(i,j,r)= SM4(i,j,r)+IM4(i,j,r);
  
  
 M1(i,j,r)=SM1(i,j,r)/N;
  M2(i,j,r)=SM2(i,j,r)/N;
  M3(i,j,r)=SM3(i,j,r)/N; 
  M4(i,j,r)=SM4(i,j,r)/N; 
  
  
  
 end;
 end;

end;
end;
