%Simulacin  para el clculo de los niveles de significacin  
%para el contraste de bondad de ajuste para tamaos de cluster constantes
%el tamao del cluster y para diferentes modelos de grado de acuerdo Es
%decir Contrastes: H nula: M3 H alternativa M2, H nula: M3 H alternativa
%M2*, H nula: M2 H alternativa M1
n=40;
%nmero total de clusters
 TC=20;
 ntot=n*TC;

%Declaramos como variables globales aquellas que van a aparecer en las
  %funciones que llamamos desde este script
  global ro2 W1 W2 W2B W3  TH01  M M01 M02 M02B M03 Pest;
  clear ro2 W1 W2 W2B W3 TH01 M M01 M02 M02B M03 Pest;

 %nmero de muestras a generar
N=10;
%Modelo loglineal que calcula las probabilidades estimadas en funcin del parmetro
  % Matrices de los diferentes modelos loglineales 
  
 % Modelo 1: Completo: landa+landaA1,2,3+landaB1,2,3+delta(acuerdo)+Beta por u i*j
 
 W1 =[1  1  0  0  1  0  0 1 1; 
     1  1  0  0  0  1  0 0 2; 
     1  1  0  0  0  0  1 0 3;
     1  1  0  0 -1 -1 -1 0 4 ; 
     1  0  1  0  1  0  0 0 2;
     1  0  1  0  0  1  0 1 4; 
     1  0  1  0  0  0  1 0 6; 
     1  0  1  0 -1 -1 -1 0 8;
     1  0  0  1  1  0  0 0 3; 
     1  0  0  1  0  1  0 0 6; 
     1  0  0  1  0  0  1 1 9; 
     1  0  0  1 -1 -1 -1 0 12;
     1 -1 -1 -1  1  0  0 0 4;
     1 -1 -1 -1  0  1  0 0 8; 
     1 -1 -1 -1  0  0  1 0 12; 
     1 -1 -1 -1 -1 -1 -1 1 16];

 
% Matriz del modelo loglineal landa+landaA1,2,3+landaB1,2,3+ medida de acuerdo para variables ordinales (MODELO (2)
 W2 =[1  1  0  0  1  0  0 1; 
     1  1  0  0  0  1  0 2; 
     1  1  0  0  0  0  1 3;
     1  1  0  0 -1 -1 -1 4; 
     1  0  1  0  1  0  0 2;
     1  0  1  0  0  1  0 4; 
     1  0  1  0  0  0  1 6; 
     1  0  1  0 -1 -1 -1 8;
     1  0  0  1  1  0  0 3; 
     1  0  0  1  0  1  0 6; 
     1  0  0  1  0  0  1 9; 
     1  0  0  1 -1 -1 -1 12;
     1 -1 -1 -1  1  0  0 4;
     1 -1 -1 -1  0  1  0 8; 
     1 -1 -1 -1  0  0  1 12 ; 
     1 -1 -1 -1 -1 -1 -1 16]; 
 % Matriz del modelo loglineal landa+landaA(1,2,3)+landaB(1,2,3)+delta(acuerdo soloen la diagonal)  (MODELO 3(2*)

  W2B =[1  1  0  0  1  0  0 1; 
     1  1  0  0  0  1  0 0; 
     1  1  0  0  0  0  1 0;
     1  1  0  0 -1 -1 -1 0; 
     1  0  1  0  1  0  0 0;
     1  0  1  0  0  1  0 1; 
     1  0  1  0  0  0  1 0; 
     1  0  1  0 -1 -1 -1 0;
     1  0  0  1  1  0  0 0; 
     1  0  0  1  0  1  0 0; 
     1  0  0  1  0  0  1 1; 
     1  0  0  1 -1 -1 -1 0;
     1 -1 -1 -1  1  0  0 0;
     1 -1 -1 -1  0  1  0 0; 
     1 -1 -1 -1  0  0  1 0 ; 
     1 -1 -1 -1 -1 -1 -1 1]; 
%Matriz del modelo loglineal landa+landaA(1,2,3)+landaB(1,2,3)(Modelo 4:independencia)
 
 W3 =[1  1  0  0  1  0  0 ; 
     1  1  0  0  0  1  0 ; 
     1  1  0  0  0  0  1 ;
     1  1  0  0 -1 -1 -1 ; 
     1  0  1  0  1  0  0 ;
     1  0  1  0  0  1  0; 
     1  0  1  0  0  0  1 ; 
     1  0  1  0 -1 -1 -1 ;
     1  0  0  1  1  0  0 ; 
     1  0  0  1  0  1  0 ; 
     1  0  0  1  0  0  1 ; 
     1  0  0  1 -1 -1 -1 ;
     1 -1 -1 -1  1  0  0 ;
     1 -1 -1 -1  0  1  0; 
     1 -1 -1 -1  0  0  1  ; 
     1 -1 -1 -1 -1 -1 -1 ]; 
 
%se realizan los contrastes jerrquicos en uno de los caminos posibles
    % con el modelo de acuerdo solo en la diagonal (2B)(M3)
    
 [M,M01] = size(W1);

M02B=size(W2B,2);
M03=size(W3,2);
 

%Inicializamos las matrices que van a contener las probabilidades estimadas
%Vectores de probabilidad estimados mediante modelo loglineal
PTH1=zeros(M,1);
TH1=zeros(M01,1);

PTH2B=zeros(M,1);
TH2B=zeros(M02B,1);
PTH3=zeros(M,1);
TH3=zeros(M03,1);

Pest=zeros(M,1);

%y los estimadores de ro

ChiTH=zeros(TC,M,5);
ChiN=zeros(TC,M);

T2B1=zeros(5,5);

T32B=zeros(5,5);

TB2B1=zeros(5,5);

TB32B=zeros(5,5);

Nu2B=zeros(1,6);
Nu3=zeros(1,6);
% Indicadores de resultados de los contrastes jerrquicos
% Para los contrastes corregidos por el efecto del diseo
alfaT=zeros(5,5,39);
alfaTB=zeros(5,5,39);
IalfaT=zeros(5,5);
IalfaTB=zeros(5,5);
sumalfaT=zeros(5,5,39);
sumalfaTB=zeros(5,5,39);

alfaT2=zeros(5,5,39);
alfaTB2=zeros(5,5,39);
IalfaT2=zeros(5,5);
IalfaTB2=zeros(5,5);
sumalfaT2=zeros(5,5,39);
sumalfaTB2=zeros(5,5,39);

alfaT_C=zeros(5,5,39);
alfaTB_C=zeros(5,5,39);
IalfaT_C=zeros(5,5);
IalfaTB_C=zeros(5,5);
sumalfaT_C=zeros(5,5,39);
sumalfaTB_C=zeros(5,5,39);

 % El valor inicial DEL VECTOR DE PROBABILIDAD QUE DESCRIBE LOS DIFERNTES PODIBLES MODELOS DE ACUERDO 
 
TH03 =[0.5521 ; 0.0512; -0.0819; 0.1122 ; -0.0840; 0.0495; -0.0150]; X03= TH03; X03(1) = TH03(1)+0.05;

 TH02B =[0.5 ; -0.04; 0.19; 0.05 ; 0.70; 0.34; -0.75; 0.06 ]; X02B= TH02B; X02B(1) = TH02B(1)+0.05;
  TH01 =[0.5612 ; 1.9834; 1.1512; -0.4032 ; 3.5075; 1.5843; -1.5419; 0.0645;0.7285 ]; 
  X01= TH01; X01(1) = TH01(1)+0.05;
  
PTH01= (exp(W1*TH01))/sum(exp(W1*TH01));

PTH02B= (exp(W2B*TH02B))/sum(exp(W2B*TH02B));
PTH03= (exp(W3*TH03))/sum(exp(W3*TH03));
%Escogemos el vector de probabilidad para generar los datos suponiendo que el modelo loglineal 
%que verifican los datos es el de independencia (M3)
PTH0=PTH03; 
 options = optimset('LargeScale','off');
 %Para cada una de las muestras calculamos el estimador de mnima fidivergencia para theta
 for r=1:39
     ro2=2.5*r/100;
   a=PTH0*(1-ro2)/ro2; 
%generamos N muestras formadas por clusters de tamao n utilizando
%comodistribucin deprobabilidad la del modelo de la hiptesis nula, de
%forma que la frecuencia de rechazos de la hipotesis es una estimacin de
%alfa
for h=1:N
      ArDat=zeros(TC,M); %valores simulados
      pm=zeros(TC,M); %Probabilidades empricas para cada cluster
     %generamos los vectores de probabilidad mediante dirichlet de parmetros
   %a y PTH0 y partir de aqu las multinomiales con dichos vectores
    %Observemos que cada fila de ArDat es una muestra de valores de un cluster
  for l=1:TC 
       ArDat(l,:)=Dirnd(ro2,a,n);
     %Calculamos el vector de probabilidad estimado para cada cluster pm  
       pm(l,:)=ArDat(l,:)/n;
  end; 
  Pest=sum(ArDat,1)'./ntot;
   
    for m=1:M
    if Pest(m)==0;
        Pest(m)=0.000001;
    end;
   end;
   
  for l=1:TC 
         Difv(l,:)= ((pm(l,:)-Pest')).^2;
    end;  
   
  %Para cada una de las muestras calculamos el estimador de mnima
 %fi-divergencia  para los siguientes valores de landa y el estimador de ro

for i=1:5
     if i==1 land=-0.5; 
    elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
    else land=2;
    end; 
   
    fiDiv_3=@(x)(sum((Pest.^(land+1))./((exp(W3*x)/sum(exp(W3*x))).^land)-1)/(land*(land+1)));
   fiDiv0_3=@(x)(Pest'*log(Pest./(exp(W3*x)/sum(exp(W3*x)))));
  
 c=@(x)[(exp(W3*x))/sum(exp(W3*x))-1;
     -(exp(W3*x))/sum(exp(W3*x))];
 ceq =@(x)[];
 restri3=@(x)deal(c(x),ceq(x));
 
     fiDiv_2B=@(x)(sum((Pest.^(land+1))./((exp(W2B*x)/sum(exp(W2B*x))).^land)-1)/(land*(land+1)));
   fiDiv0_2B=@(x)(Pest'*log(Pest./(exp(W2B*x)/sum(exp(W2B*x)))));
  
 c=@(x)[(exp(W2B*x))/sum(exp(W2B*x))-1;
     -(exp(W2B*x))/sum(exp(W2B*x))];
 ceq =@(x)[];
 restri2B=@(x)deal(c(x),ceq(x));
    
   
 fiDiv_1=@(x)(sum((Pest.^(land+1))./((exp(W1*x)/sum(exp(W1*x))).^land)-1)/(land*(land+1)));
   fiDiv0_1=@(x)(Pest'*log(Pest./((exp(W1*x))/sum(exp(W1*x)))));
 
 c1=@(x)[(exp(W1*x))/sum(exp(W1*x))-1;
     -(exp(W1*x))/sum(exp(W1*x))];
 ceq =@(x)[];
 restri1=@(x)deal(c1(x),ceq(x));
 
 if land==0 
      %llamamos a funcin de optimizacin no lineal con restricciones lineales y no lineales
  TH1(:,i)= fmincon(fiDiv0_1,X01,[],[],[],[],[],[],restri1,options);
 
   TH2B(:,i)= fmincon(fiDiv0_2B,X02B,[],[],[],[],[],[],restri2B,options);
   TH3(:,i)= fmincon(fiDiv0_3,X03,[],[],[],[],[],[],restri3,options);
  
  else
  TH1(:,i)= fmincon(fiDiv_1,X01,[],[],[],[],[],[],restri1,options);
  
   TH2B(:,i)= fmincon(fiDiv_2B,X02B,[],[],[],[],[],[],restri2B,options);
   TH3(:,i)= fmincon(fiDiv_3,X03,[],[],[],[],[],[],restri3,options);
 end;

PTH1(:,i)= (exp(W1*TH1(:,i)))/sum(exp(W1*TH1(:,i)));
PTH2B(:,i)= (exp(W2B*TH2B(:,i)))/sum(exp(W2B*TH2B(:,i)));
PTH3(:,i)= (exp(W3*TH3(:,i)))/sum(exp(W3*TH3(:,i)));
 
   % Calculamos el estimador del coeficiente de correlacin intracluster y
  % el coeficiente de sobredispersin segn los dos modelos loglineales
    

   % Para evitar la divisin por cero sustituimos el sumando por su valor
   for l=1:TC 
     for m=1:M 
       if PTH1(m,i)==0 ChiTH1(l,m,i)=0;   
       else ChiTH1(l,m,i)=Difv(l,m)/PTH1(m,i);
       end;
       if PTH2B(m,i)==0 ChiTH2B(l,m,i)=0;   
       else  ChiTH2B(l,m,i)=Difv(l,m)/PTH2B(m,i);
       end;
       if PTH3(m,i)==0 ChiTH3(l,m,i)=0;   
       else  ChiTH3(l,m,i)=Difv(l,m)/PTH3(m,i);
       end;
         ChiN(l,m)=Difv(l,m)/Pest(m);
     end;  
    end;
 %Con la probabilidad estimada mediante el modelo loglineal y los estimadores de m fi-divergencia
%calculamos el estimador de ro para cada uno de los valores de landa
    %Sumamos desde j=1 hasta M
  Nu1(1)=(sum(sum(ChiN))*n)/((TC-1)*(M-1));
  Nu1(i+1)=(sum(sum(ChiTH1(:,:,i)))*n)/((TC-1)*(M-1));
 Nu2B(1)=(sum(sum(ChiN))*n)/((TC-1)*(M-1));
  Nu2B(i+1)=(sum(sum(ChiTH2B(:,:,i)))*n)/((TC-1)*(M-1));
  Nu3(1)=(sum(sum(ChiN))*n)/((TC-1)*(M-1));
  Nu3(i+1)=(sum(sum(ChiTH3(:,:,i)))*n)/((TC-1)*(M-1));
  
end;

%Clculo de los estadsticos para el contraste de hiptesis anidadas
 %Observemos que Fi1 (medida de divrgenca para medir la discrepancia) viene dado por filas y Fi2 (utilizada para obtener el
 %estimador) viene por columnas y el coeficiente Nu es estimado con Fi2 
 %
for j=1:5
  for i=1:5
       if i==1 land=-0.5; 
       elseif i==2 land=0; 
       elseif i==3 land=2/3; 
        elseif i==4 land=1;
       else land=2;
      end;
   if land==0; 
     for m=1:M;
      if PTH1(m,j)==0  Div12B(m)=0;
      else  Div12B(m,j)=PTH1(m,j)*log(PTH1(m,j)/PTH2B(m,j));
       end;
       
       if PTH2B(m,j)==0  Div2B3(m)=0;
      else  Div2B3(m,j)=PTH2B(m,j)*log(PTH2B(m,j)/PTH3(m,j));
       end;
     end;
     %Estadtsticos sin corregir el efecto del diseo
     
      T2B1(i,j)=2*ntot*sum(Div12B(:,j));
    
      T32B(i,j)=2*ntot*sum(Div2B3(:,j));
      
   %Estadsticos corregidos por el efecto del diseo   
     
      TB2B1(i,j)=2*ntot*sum(Div12B(:,j))/Nu2B(j+1);
      
      TB32B(i,j)=2*ntot*sum(Div2B3(:,j))/Nu3(j+1);
      
    else
     
      T2B1(i,j)=2*ntot*(sum((PTH1(:,j).^(land+1))./PTH2B(:,j).^land)-1)/(land*(land+1));
      
      T32B(i,j)=2*ntot*(sum((PTH2B(:,j).^(land+1))./PTH3(:,j).^land)-1)/(land*(land+1));
      
   
       TB2B1(i,j)=2*ntot*(sum((PTH1(:,j).^(land+1))./PTH2B(:,j).^land)-1)/(land*(land+1))/Nu2B(j+1);
      
       TB32B(i,j)=2*ntot*(sum((PTH2B(:,j).^(land+1))./PTH3(:,j).^land)-1)/(land*(land+1))/Nu3(j+1);
    end;
    % se realizan los contrastes jerrquicos en uno de los caminos posibles
    % con el modelo de acuerdo solo en la diagonal (2B)(M3)
    %adems calculamos los niveles de significacin de froma independiente
    %de cada uno de los contrastes realizados
 %Utilizando el estadstico corregido 
  if TB2B1(i,j)>chi2inv(0.95,M01-M02B) IalfaTB(i,j)=1; else IalfaTB(i,j)=0;end;
 sumalfaTB(i,j,r)= sumalfaTB(i,j,r)+IalfaTB(i,j);
 
  if TB32B(i,j)>chi2inv(0.95,M02B-M03) IalfaTB2(i,j)=1; else IalfaTB2(i,j)=0;end;
 sumalfaTB2(i,j,r)= sumalfaTB2(i,j,r)+IalfaTB2(i,j);
 
   %Utilizando el estadistico sin corregir
  
  if T2B1(i,j)>chi2inv(0.95,M01-M02B) IalfaT(i,j)=1; else IalfaT(i,j)=0;end;
 sumalfaT(i,j,r)= sumalfaT(i,j,r)+IalfaT(i,j);
 
  if T32B(i,j)>chi2inv(0.95,M02B-M03) IalfaT2(i,j)=1; else IalfaT2(i,j)=0;end;
 sumalfaT2(i,j,r)= sumalfaT2(i,j,r)+IalfaT2(i,j);
 
 %Calculamos el alfa conjunto suponiendo hiptesis nula cierta de independencia 
  %Utilizando el estadstico corregido 
  if TB2B1(i,j)>chi2inv(0.975,M01-M02B)
      IalfaTB_C(i,j)=1;
      if TB32B(i,j)>chi2inv(0.975,M02B-M03) IalfaTB_C(i,j)=IalfaTB_C(i,j)+1;
        else IalfaTB_C(i,j)= IalfaTB_C(i,j);
      end;
  else IalfaTB_C(i,j)=0;end;
 sumalfaTB_C(i,j,r)= sumalfaTB_C(i,j,r)+IalfaTB_C(i,j);
 
  %Utilizando el estadstico sin corregir 
  if T2B1(i,j)>chi2inv(0.95,M01-M02B)
      IalfaT_C(i,j)=1;
      if T32B(i,j)>chi2inv(0.95,M02B-M03) IalfaT_C(i,j)=IalfaT_C(i,j)+1;
        else IalfaT_C(i,j)= IalfaT_C(i,j);
      end;
  else IalfaT_C(i,j)=0;end;
   sumalfaT_C(i,j,r)= sumalfaT_C(i,j,r)+IalfaT_C(i,j);
   
 alfaT(i,j,r)=sumalfaT(i,j,r)/N;
  alfaTB(i,j,r)=sumalfaTB(i,j,r)/N;
 
 alfaT2(i,j,r)=sumalfaT2(i,j,r)/N;
  alfaTB2(i,j,r)=sumalfaTB2(i,j,r)/N;
  
  alfaTB_C(i,j,r)=sumalfaTB_C(i,j,r)/(2*N);
  
     alfaT_C(i,j,r)=sumalfaT_C(i,j,r)/(2*N); 


  
 end;
 end;

end;
end;
